#include <stdio.h>
#include <X11/Xlib.h>
#include "xc.h"

void redraw_board()
{
    draw_board(True);
}

void begin_chess(move)
char *move;
{
    /* move to beginning of game */

    strcpy(move, "backward 1000");
}

void end_chess(move)
char *move;
{
    /* move to end of game */

    strcpy(move, "forward 1000");
}

void forward_chess(move)
char *move;
{
    /* move forward 1 move */

    strcpy(move, "forward");
}

void backward_chess(move)
char *move;
{
    /* move backward 1 move */

    strcpy(move, "backward");
}

void abort_chess(move)
char *move;
{
    /* send abort offer to opponent */

    strcpy(move, "abort");
}

void resign_chess(move)
char *move;
{
    /* resign game */

    strcpy(move, "resign");
}

void quit_chess(move)
char *move;
{
    /* quit ICS */

    strcpy(move, "quit");
}

void who_chess(move)
char *move;
{
    /* list of people logged in */

    strcpy(move, "who");
}

void adjourn_chess(move)
char *move;
{
    /* request adjournment */

    strcpy(move, "adjourn");
}

void games_chess(move)
char *move;
{
    /* get list of games */

    strcpy(move, "games");
}

void draw_chess(move)
char *move;
{
    /* offer draw to opponent */

    strcpy(move, "draw");
}

void decline_chess(move)
char *move;
{
    /* decline opponent's offer */

    strcpy(move, "decline");
}

void players_chess(move)
char *move;
{
    /* show list of players */

    strcpy(move, "players");
}

void flag_chess(move)
char *move;
{
    /* flag game */

    strcpy(move, "flag");
}

void accept_chess(move)
char *move;
{
    /* accept offer */

    strcpy(move, "accept");
}

void refresh_chess(move)
char *move;
{
    /* refresh board */

    strcpy(move, "refresh");
}

int events(move, new_telnet)
char *move;
int new_telnet;     /* = 1 means called from new telnet.c; 0 otherwise */
{
    int i, j;
    int x, y;
    XEvent theEvent;
    Bool got_event;
    char *letters = "abcdefgh";
    char square[3];
    int moved = 0;

    static int first = 1;
    static char oldsquare[3];

    square[0] = '\0';

    /* processes button events */

    if (new_telnet)
    {
        /* Blocks (not really, because we know there is an event) */

        XWindowEvent(theDisplay, theWindow, theEventMask, &theEvent);
        got_event = True;
    }
    else
    {
        /* don't want to block; there might not be any event in the queue */

        got_event = XCheckWindowEvent(theDisplay, theWindow, theEventMask,
                                      &theEvent);
    }

    if (!got_event) return 0;

    /* got an event */

    switch(theEvent.type)
    {
      case ButtonPress:
        first = 1;
      case ButtonRelease:

        x = theEvent.xbutton.x;
        y = theEvent.xbutton.y;
        if (theEvent.type == ButtonPress)
        {
            for (i=0; i<NBUTTONS; i++)
            {
                if (in_button(x, y, buttons[i]))
                {
                    (buttons[i].func)(move);
                    return 1;
                }
            }
        }

        /* figure out which square we are talking about */

        i = x/SQUARESIZE;
        j = 8 - y/SQUARESIZE;

        if (i >= 0 && i < 8 && j >= 1 && j <= 8)
        {
            /* User clicked inside board */
            if (!i_am_white)
            {
                j = 9 - j;
                i = 7 - i;
            }
            sprintf(square, "%c%1d", letters[i], j);

            if (first)
            {
                strcpy(oldsquare, square);
                first = 0;
            }
            else
            {
                sprintf(move, "%s-%s", oldsquare, square);
                if (move[0] == move[3] && move[1] == move[4] &&
                    move[2] == '-')
                {
                    /* user clicked on piece and released it (do nothing) */

                    strcpy(move, "");
                    moved = 0;
                }
                else
                {
                    moved = 1;
                }
                first = 1;
            }
        }
        else
        {
            first = 1;         /* move discarded */
        }
        break;

      case Expose:
        redraw_board();
        break;
    }
    if (moved && move[0] == 'e' &&
        ((i_am_white && squares[4]['8'-move[1]] == 'K') ||
        ((!i_am_white) && squares[3][move[1]-'1'] == 'k')))
    {
        if (move[3] == 'g') strcpy(move, "o-o");
        if (move[3] == 'c') strcpy(move, "o-o-o");
    }
    return moved;
}
