#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#define MAIN
#include "xc.h"
#undef MAIN
#include "bkw.bm"

char Usage[] = "Usage: %s machine [portnum] (default port is 5000)\n";

main(argc, argv)
int argc;
char **argv;
{
    Window openWindow();
    XSizeHints   hints;
    char         *name = "xics";
    Pixmap icon;

/* ----------------------------------------------------------- */

    if (argc != 3 && argc != 2)
    {
        printf(Usage, argv[0]);
        exit(2);
    }

    /* initializations */

    theDisplay = XOpenDisplay(NULL);

    if (theDisplay == NULL)
    {
        fprintf(stderr, "Could not open display on %s\n", XDisplayName(NULL));
        fprintf(stderr, "Either your DISPLAY variable is NOT SET\n");
        fprintf(stderr, "Or it is set to an invalid display.\n");
        fprintf(stderr, "Please set DISPLAY and run again.\n");
        exit(1);
    }

    theScreen = DefaultScreen(theDisplay);
    theDepth = DefaultDepth(theDisplay, theScreen);
    theBlackPixel = BlackPixel(theDisplay, theScreen);
    theWhitePixel = WhitePixel(theDisplay, theScreen);

    theWindow = openWindow(WindowLeft, WindowTop, WindowSize,
                           WindowSize + Statusheight,
                           &theGC, theBlackPixel, theWhitePixel);

    XSelectInput(theDisplay, theWindow, theEventMask);

    icon = XCreatePixmapFromBitmapData(theDisplay,
           DefaultRootWindow(theDisplay), bkw_bits,
           SQUARESIZE, SQUARESIZE, 1, 0, 1);

    hints.flags = PSize | PMinSize | PMaxSize;
    hints.width = hints.min_width = hints.max_width = WindowSize;
    hints.height = hints.min_height =
    hints.max_height = WindowSize + Statusheight;

    XSetStandardProperties(theDisplay, theWindow, name, name, icon,
                           argv, argc, &hints);

    /*PDS*/     
    initclock();
    
    i_am_white = 1;
    if (argc == 2)
    {
        telnet(argv[1], "5000");
    }
    else
    {
        telnet(argv[1], argv[2]);
    }

    XDestroyWindow(theDisplay, theWindow);
    XCloseDisplay(theDisplay);

    return 0;
}
