#include <stdio.h>
#include <X11/Xlib.h>
#include "xc.h"

#define strneq(a,b,n) (strncmp((a),(b),(n)) == 0)

read_positions_1(line)
char *line;
{
    /* parses argument looking for a board (style 1) */

    int i, j;
    static int first = 1;
    static int got_board = 0;
    static int row = 0;
    static int skip_line = 0;
    char player; /*PDS*/

    if (first)
    {
        for (i=0; i<8; i++)
        {
            for (j=0; j<8; j++)
            {
                squares[i][j] = ' ';
            }
        }
        draw_board(True);

        first = 0;
    }

    if (!got_board)
    {
        for (i=0; i<5; i++)     /* board must begin within first 5 columns */
        {
            if (strneq(&line[i], "	---------------------------------", 34))
            {
                /* now got a board */

                got_board = 1;
                return;
            }
        }
    }
    else
    {
        if (skip_line)
        {
            skip_line = 0;
            row++;

            if (row == 8)
            {
                /* show the position */

                draw_board(False);
                got_board = 0;
                skip_line = 0;
                row = 0;               /* RESET ALL */

		/* grab the clock information */
		clockCol = 15;
		sscanf(text[0]," Move # : %*d (%c",&player);
		if (player == text[3][1]) 
		   clockLine = 3;
		else
		   clockLine=4;
		   
		sscanf(text[clockLine]+clockCol," %ld : %ld",
		       &currTime,&currClock);
		currClock += 60*currTime;		   
		currTime = time(NULL);
            }
            return;
        }

        for (i=0; i<8; i++)
        {
            old_squares[i][row] = squares[i][row];
        }
        text[row][0] = '\0';

        if (row == 0 && strstr(line, "     8  |") != NULL) i_am_white = 1;
        if (row == 0 && strstr(line, "     1  |") != NULL) i_am_white = 0;

        for (i=9; i<38; i+=4)
        {
            if (strneq(&line[i], "   ", 3)) squares[(i-9)/4][row] = ' ';
            if (strneq(&line[i], " P ", 3)) squares[(i-9)/4][row] = 'P';
            if (strneq(&line[i], " *P", 3)) squares[(i-9)/4][row] = 'p';
            if (strneq(&line[i], " R ", 3)) squares[(i-9)/4][row] = 'R';
            if (strneq(&line[i], " *R", 3)) squares[(i-9)/4][row] = 'r';
            if (strneq(&line[i], " K ", 3)) squares[(i-9)/4][row] = 'K';
            if (strneq(&line[i], " *K", 3)) squares[(i-9)/4][row] = 'k';
            if (strneq(&line[i], " Q ", 3)) squares[(i-9)/4][row] = 'Q';
            if (strneq(&line[i], " *Q", 3)) squares[(i-9)/4][row] = 'q';
            if (strneq(&line[i], " B ", 3)) squares[(i-9)/4][row] = 'B';
            if (strneq(&line[i], " *B", 3)) squares[(i-9)/4][row] = 'b';
            if (strneq(&line[i], " N ", 3)) squares[(i-9)/4][row] = 'N';
            if (strneq(&line[i], " *N", 3)) squares[(i-9)/4][row] = 'n';
        }

        /* text to the right goes in the status window */

        if (strlen(line) < 46)
        {
            text[row][0] = '\0';
        }
        else
        {
            strcpy(&text[row][0], &line[45]);
        }

        skip_line = 1;       /* skip next line */
    }
}
