#include <stdio.h>
#include <X11/Xlib.h>
#include "xc.h"

#define strneq(a,b,n) (strncmp((a),(b),(n)) == 0)

read_positions_8(line)
char *line;
{
    /* parses argument looking for a board (style 8) */

    int i, j, k, igame, imove, iclock;
    char templine[512], tempname[512];
    int ijunk;

    static int first = 1;

    if (first)
    {
        for (i=0; i<8; i++)
        {
            for (j=0; j<8; j++)
            {
                squares[i][j] = ' ';
            }
        }
        draw_board(True);

        first = 0;
    }

    for (i=0; i<5; i++)       /* board must begin within first 5 columns */
    {
        if (strneq(&line[i], "#@#", 3))
        {
            strcpy(templine, line);
            strcpy(line, &templine[i]);
            break;
        }
    }

    if (strneq(line, "#@#", 3))
    {
        for (i=0; i<8; i++)
        {
            for (j=0; j<8; j++)
            {
                old_squares[i][j] = squares[i][j];
            }
            text[i][0] = '\0';
        }

        /* fill the board in "squares" */

/*
#@#000observer        :aaa             :RNBQKBNRPPPPPPPP                                pppppppprnbqkbnr001W39390360003600@#@

       Match information offsets, descriptions and lengths:
       +3   Game # (3)
       +6   White's name (16 + ':' = 17)
       +23  Black's name (16 + ':' = 17)
       +40  Board  (64)
       +104 Move # (3)
       +107 Whose move (1)
       +108 White Strength (2)
       +110 Black Strength (2)
       +112 White Time (5)
       +117 Black Time (5)
       +122 Move string (variable)
A "*" instead of a ":" after the name implies that the person using xics
is playing the game. Need to flip the board if he is playing with black
pieces.
*/
        k = 40;

        if (line[39] == '*')
        {
            /* flip the board */

            i_am_white = 0;
            for (i=0; i<8; i++)
            {
                for (j=0; j<8; j++)
                {
                    squares[7-j][i] = line[k];
                    k++;
                }
            }
        }
        else
        {
            i_am_white = 1;
            for (i=0; i<8; i++)
            {
                for (j=0; j<8; j++)
                {
                    squares[j][7-i] = line[k];
                    k++;
                }
            }
        }

        /* text goes in the status window */

        /* game number and names of players */

        text[0][0] = '(';
        strncpy(templine, &line[3], 3);
        templine[3] = '\0';
        sscanf(templine, "%d", &igame);
        sprintf(&text[0][1], "%d) ", igame);
        k = strlen(text[0]);

        strncpy(templine, &line[6], 16);
        templine[16] = '\0';
        sscanf(templine, "%s", tempname);
        strcpy(&text[0][k], tempname);  k += strlen(tempname);
        text[0][k] = '-';  k++;
        strncpy(templine, &line[23], 16);
        templine[16] = '\0';
        sscanf(templine, "%s", tempname);
        strcpy(&text[0][k], tempname);

        /* move number and who to move */

        strcpy(text[1], "Move # : "); k = 9;
        strncpy(templine, &line[104], 3);
        templine[3] = '\0';
        sscanf(templine, "%d", &imove);
        sprintf(&text[1][k], "%d ", imove);
        k = strlen(text[1]);
        if (line[107] == 'W') strcat(text[1], "(White)");
        if (line[107] == 'B') strcat(text[1], "(Black)");

        /* Previous move */

        if (line[107] == 'W') strcpy(text[2], "Black moves : ");
        if (line[107] == 'B') strcpy(text[2], "White moves : ");

        strcat(text[2], &line[122]);
        i = 0;
        while (text[2][i] != '@') i++;
        text[2][i] = '\0';

        /* one blank line */

        strcpy(text[3], " ");

        /* White strength */

        strcpy(text[4], "White Strength : ");
        strncat(text[4], &line[108], 2);
        text[4][19] = '\0';

        /* Black strength */

        strcpy(text[5], "Black Strength : ");
        strncat(text[5], &line[110], 2);
        text[4][19] = '\0';

        /* White clock */

        strcpy(text[6], "White Clock : ");
        strncpy(templine, &line[112], 5);
        templine[5] = '\0';
        sscanf(templine, "%d", &iclock);
        ijunk = (iclock/60 != 0 ? abs(iclock % 60) : iclock % 60);
        sprintf(templine, "%d : %02d", iclock/60, ijunk);
        strcat(text[6], templine);
/*PDS*/
	if (line[107]=='W') 
	{
	   clockLine = 6; clockCol = 14;	   
	   currTime = time(NULL);
	   currClock = iclock;
	}
	
        /* Black clock */

        strcpy(text[7], "Black Clock : ");
        strncpy(templine, &line[117], 5);
        templine[5] = '\0';
        sscanf(templine, "%d", &iclock);
        ijunk = (iclock/60 != 0 ? abs(iclock % 60) : iclock % 60);
        sprintf(templine, "%d : %02d", iclock/60, ijunk);
        strcat(text[7], templine);
/*PDS*/
	if (line[107]=='B') 
	{
	   clockLine = 7; clockCol = 14;	   
	   currTime = time(NULL);
	   currClock = iclock;
	}

        /* show the position */

        draw_board(False);
    }
}
