#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include "xc.h"

extern int theDepth;
extern unsigned long theBlackPixel;
extern unsigned long theWhitePixel;

#define BORDER_WIDTH 2

Window openWindow(x, y, width, height, theNewGC, border, background)
int x, y;
int width, height;
GC *theNewGC;
unsigned long border, background;
{
    XSetWindowAttributes theWindowAttributes;
    Window theNewWindow;

/* --------------------------------------------------------------- */

    /* Create a Window */

    /* set attributes */

    theWindowAttributes.border_pixel = border;
    theWindowAttributes.background_pixel = background;
    theWindowAttributes.override_redirect = True;

    /* open the window */

    theNewWindow = XCreateSimpleWindow(theDisplay,
                                       RootWindow(theDisplay, theScreen),
                                       x, y, width, height, BORDER_WIDTH,
                                       theBlackPixel, theWhitePixel);

    /* create a graphics context */

    if (createGC(theNewWindow, theNewGC) == 0)
    {
        XDestroyWindow(theDisplay, theNewWindow);
        return (Window) 0;
    }

    /* make the window visible */

    XMapWindow(theDisplay, theNewWindow);

    /* flush queued requests */

    XFlush(theDisplay);

    return theNewWindow;
}


createGC(theNewWindow, theNewGC)
Window theNewWindow;
GC *theNewGC;
{
    XGCValues theGCValues;

    *theNewGC = XCreateGC(theDisplay, theNewWindow, (unsigned long) 0,
                          &theGCValues);

    if (*theNewGC == 0)
    {
        return 0;
    }
    else
    {
        XSetForeground(theDisplay, *theNewGC, theBlackPixel);
        XSetBackground(theDisplay, *theNewGC, theWhitePixel);
        return 1;
    }
}
