/* Where the graphics window is to be positioned */

#define WindowLeft 10
#define WindowTop 10

/* the chessboard is a square of size WindowSize-by-WindowSize */

#ifdef bitmaps40
#define NBUTTONS 8
#define WindowSize 320
#endif

#ifdef bitmaps80
#define NBUTTONS 16
#define WindowSize 640
#endif

#ifdef bitmaps64
#define NBUTTONS 16
#define WindowSize 512
#endif

/* The Status window contains time, move, etc. */

#ifdef bitmaps40
#define Statusheight 180
#else
#define Statusheight 155
#endif

/* Status window is of the same width as the chessboard */

#define Statuswidth WindowSize

/* 8 squares along each dimension */

#define SQUARESIZE (WindowSize/8)

/* event mask */

#define theEventMask (ButtonReleaseMask | ButtonPressMask | ExposureMask)

extern void redraw_board();

extern void quit_chess();
extern void flag_chess();
extern void accept_chess();
extern void refresh_chess();
extern void draw_chess();
extern void resign_chess();
extern void decline_chess();
extern void abort_chess();
extern void adjourn_chess();
extern void games_chess();
extern void who_chess();
extern void players_chess();
extern void end_chess();
extern void begin_chess();
extern void forward_chess();
extern void backward_chess();

extern void exit();
extern void initclock();
extern void checkclock();
extern void telnet();

/* Buttons */

typedef struct
{
    int x, y;
    int width, height;
    char *command;
    void (*func)();
} BUTTONS;

#ifdef MAIN
#ifdef bitmaps40
BUTTONS buttons[NBUTTONS] =
   {{260, WindowSize+155, 50, 20, " QUIT ", quit_chess},
    {170, WindowSize+155, 50, 20, " PLAY ", accept_chess},
    {110, WindowSize+155, 50, 20, " FLAG ", flag_chess},
    {10, WindowSize+155, 80, 20, " REFRESH ", refresh_chess},

    {WindowSize-31, WindowSize+10, 30, 30, " >>", end_chess},
    {WindowSize-62, WindowSize+10, 30, 30, "  >", forward_chess},
    {WindowSize-93, WindowSize+10, 30, 30, "  <", backward_chess},
    {WindowSize-124, WindowSize+10, 30, 30, " <<", begin_chess}};
#else
BUTTONS buttons[NBUTTONS] =
   {{WindowSize-80, WindowSize+40, 60, 20, " QUIT ", quit_chess},
    {WindowSize-160, WindowSize+40, 60, 20, " FLAG ", flag_chess},
    {WindowSize-240, WindowSize+40, 60, 20, " ACCEPT ", accept_chess},

    {WindowSize-80, WindowSize+70, 60, 20, " WHO ", who_chess},
    {WindowSize-160, WindowSize+70, 60, 20, " RESIGN ", resign_chess},
    {WindowSize-240, WindowSize+70, 60, 20, " DECLINE ", decline_chess},

    {WindowSize-80, WindowSize+100, 60, 20, " GAMES ", games_chess},
    {WindowSize-160, WindowSize+100, 60, 20, " DRAW ", draw_chess},
    {WindowSize-240, WindowSize+100, 60, 20, " ABORT ", abort_chess},

    {WindowSize-80, WindowSize+130, 60, 20, " PLAYERS ", players_chess},
    {WindowSize-160, WindowSize+130, 60, 20, " REFRESH ", refresh_chess},
    {WindowSize-240, WindowSize+130, 60, 20, " ADJOURN ", adjourn_chess},

    {WindowSize-31, WindowSize+5, 30, 30, " >>", end_chess},
    {WindowSize-62, WindowSize+5, 30, 30, "  >", forward_chess},
    {WindowSize-93, WindowSize+5, 30, 30, "  <", backward_chess},
    {WindowSize-124, WindowSize+5, 30, 30, " <<", begin_chess}};
#endif
#else
extern BUTTONS buttons[];
#endif
#define in_button(x,y,b) ((b.x < x) && (b.y < y) && \
                          (x < (b.x + b.width)) && (y < (b.y + b.height)))

#ifdef MAIN
#define EXTERN
#else
#define EXTERN extern
#endif

EXTERN char squares[8][8], old_squares[8][8];    /* chess pieces */
EXTERN char text[8][80];                         /* text in status window */
EXTERN Display *theDisplay;
EXTERN Window theWindow;
EXTERN int theScreen;
EXTERN GC theGC;
EXTERN int i_am_white;
EXTERN int theDepth;
EXTERN unsigned long theBlackPixel;
EXTERN unsigned long theWhitePixel;

/*PDS*/
EXTERN int clockLine; /* in the text[] array */
EXTERN int clockCol; /* offset in text[clockLine] */
EXTERN long currClock,currTime;
